// FDTransfer.cpp : implementation file
//

#include "stdafx.h"
#include "FDTransfer.h"
#include "..\eMule.h"
#include "..\otherfunctions.h"

// CFDTransfer dialog

IMPLEMENT_DYNCREATE(CFDTransfer, CPropertyPage)

CFDTransfer::CFDTransfer() : CPropertyPage(CFDTransfer::IDD)
{
	//{{AFX_DATA_INIT(CFDTransfer)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_pFile = NULL;
}

CFDTransfer::~CFDTransfer()
{
}

void CFDTransfer::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFDTransfer)
	DDX_Control(pDX, IDC_TRANSFERRINGSRC_VAL, m_ctrlTransferringSources);
	DDX_Control(pDX, IDC_TRANSFERRED_VAL, m_ctrlTransferred);
	DDX_Control(pDX, IDC_PARTCNT_VAL, m_ctrlPartCnt);
	DDX_Control(pDX, IDC_LASTSEENCOMPLETE_VAL, m_ctrlLastSeenComplete);
	DDX_Control(pDX, IDC_ICHRECOVERED_VAL, m_ctrlICHrecovered);
	DDX_Control(pDX, IDC_FOUNDSRC_VAL, m_ctrlFoundSources);
	DDX_Control(pDX, IDC_DATARATE_VAL, m_ctrlDatarate);
	DDX_Control(pDX, IDC_COMPLETEDSIZE_VAL, m_ctrlCompletedSize);
	DDX_Control(pDX, IDC_AVAILABLEPARTS_VAL, m_ctrlAvailableParts);
	DDX_Control(pDX, IDC_LASTRECEPTION_VAL, m_ctrlLastReception);
	DDX_Control(pDX, IDC_COMPPERC_VAL, m_ctrlCompPerc);
	DDX_Control(pDX, IDC_CORRUPTIONLOSS_VAL, m_ctrlCorruptionLoss);
	DDX_Control(pDX, IDC_COMPRESSIONGAIN_VAL, m_ctrlCompressionGain);
	DDX_Control(pDX, IDC_CORRUPTIONLOSS_PERC, m_ctrlCorruptionLossPerc);
	DDX_Control(pDX, IDC_COMPRESSIONGAIN_PERC, m_ctrlCompressionGainPerc);
	DDX_Control(pDX, IDC_SIZEONDISK_VAL, m_ctrlSizeOnDisk);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFDTransfer, CPropertyPage)
	//{{AFX_MSG_MAP(CFDTransfer)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFDTransfer message handlers
/////////////////////////////////////////////////////////////////////////////

void CFDTransfer::Update()
{
	EMULE_TRY

	if (m_pFile == NULL)
		return;

	if (!::IsWindow(GetSafeHwnd()))
		return;

	CString strBuffer;

	strBuffer.Format(_T("%u"), m_pFile->GetSourceCount());
	m_ctrlFoundSources.SetWindowText(strBuffer);
	strBuffer.Format(_T("%u"), m_pFile->GetTransferringSrcCount());
	m_ctrlTransferringSources.SetWindowText(strBuffer);
	
	strBuffer.Format(_T("%u (%u)"), m_pFile->GetPartCount(), m_pFile->GetHashCount());
	m_ctrlPartCnt.SetWindowText(strBuffer);

	double		dblPartsPercent = 0.0;

	if (m_pFile->GetPartCount() > 0.0)
	{
		dblPartsPercent = static_cast<double>((m_pFile->GetAvailablePartCount()*100.0) / m_pFile->GetPartCount());
	}
	strBuffer.Format(_T("%u (%.1f%%)"), m_pFile->GetAvailablePartCount(), dblPartsPercent);
	m_ctrlAvailableParts.SetWindowText(strBuffer);
	
	m_ctrlLastSeenComplete.SetWindowText( (m_pFile->lastseencomplete == NULL) ?
		GetResString(IDS_NEVER) : m_pFile->LocalizeLastSeenComplete() );

	m_ctrlTransferred.SetWindowText(CastItoXBytes(m_pFile->GetTransferred()));
	m_ctrlCompletedSize.SetWindowText(CastItoXBytes(m_pFile->GetCompletedSize()));

	if (m_pFile->GetPercentCompleted() >= 0.0)
	{
		strBuffer.Format(_T("%.2f %%"), m_pFile->GetPercentCompleted());
		m_ctrlCompPerc.SetWindowText(strBuffer);
	}
	else
	{
		m_ctrlCompPerc.SetWindowText(_T("?"));
	}

	if(m_pFile->GetDataRate() != (uint32)-1)
	{
		strBuffer.Format(_T("%.2f %s"), static_cast<double>(m_pFile->GetDataRate())/1024.0, GetResString(IDS_KBYTESEC));
	}
	else
	{
		strBuffer.Format(_T("? %s"), GetResString(IDS_KBYTESEC));
	}
	m_ctrlDatarate.SetWindowText(strBuffer);
	
	m_ctrlLastReception.SetWindowText( (m_pFile->GetTransferred() == 0) ?
		GetResString(IDS_NEVER) : m_pFile->LocalizeLastDownTransfer());

	m_ctrlCorruptionLoss.SetWindowText(CastItoXBytes(m_pFile->GetLostDueToCorruption()));
	m_ctrlCompressionGain.SetWindowText(CastItoXBytes(m_pFile->GetGainDueToCompression()));

	uint32 filesize = (( m_pFile->GetStatus() == PS_COMPLETING) || (m_pFile->GetStatus() == PS_COMPLETE) ? (m_pFile->GetFileSize()) : m_pFile->GetCompletedSize());
	strBuffer.Format(_T("%.2f %%"), (filesize != 0) ? (100 * static_cast<double>(m_pFile->GetLostDueToCorruption()) / static_cast<double>(filesize)) : 0);
	m_ctrlCorruptionLossPerc.SetWindowText(strBuffer);
	strBuffer.Format(_T("%.2f %%"), (filesize != 0) ? (100 * static_cast<double>(m_pFile->GetGainDueToCompression()) / static_cast<double>(filesize)) : 0);
	m_ctrlCompressionGainPerc.SetWindowText(strBuffer);
	strBuffer.Format("%u", m_pFile->TotalPacketsSavedDueToICH());
	m_ctrlICHrecovered.SetWindowText(strBuffer);
	m_ctrlSizeOnDisk.SetWindowText(CastItoXBytes(m_pFile->GetRealFileSize()));

	EMULE_CATCH
}

BOOL CFDTransfer::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	Localize();
	Update();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CFDTransfer::Localize()
{
	static const int s_aiResTbl[][2] =
	{
		{ IDC_FOUNDSRC_LBL, IDS_FD_SOURCES },
		{ IDC_TRANSFERRINGSRC_LBL, IDS_FD_TRANSI },
		{ IDC_PARTCNT_LBL, IDS_FD_PARTS },
		{ IDC_LASTSEENCOMPLETE_LBL, IDS_LASTSEENCOMPL },
		{ IDC_TRANSFERRED_LBL, IDS_SF_TRANS },
		{ IDC_COMPLETEDSIZE_LBL, IDS_FD_COMPSIZE },
		{ IDC_DATARATE_LBL, IDS_FD_DATARATE },
		{ IDC_LASTRECEPTION_LBL, IDS_FD_LASTCHANGE },
		{ IDC_CORRUPTIONLOSS_LBL, IDS_FD_CORRUPTION },
		{ IDC_COMPRESSIONGAIN_LBL, IDS_FD_COMPRESSION },
		{ IDC_ICHRECOVERED_LBL, IDS_FD_RECOVERED },
		{ IDC_SIZEONDISK_LBL, IDS_SIZE_ON_DISK }
	};

	EMULE_TRY

	if (GetSafeHwnd())
	{
		for (uint32 i = 0; i < ELEMENT_COUNT(s_aiResTbl); i++)
			SetDlgItemText(s_aiResTbl[i][0], GetResString(static_cast<UINT>(s_aiResTbl[i][1])));

		SetDlgItemText(IDC_AVAILABLEPARTS_LBL, GetResString(IDS_INFLST_FILE_PARTAVAILABLE) + _T(':'));
	}

	EMULE_CATCH
}
