#pragma once
#include "afxwin.h"
#include "afxcmn.h"


/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
class CPPgSecurity : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgSecurity)

public:
	CPPgSecurity();
	virtual ~CPPgSecurity();

	enum { IDD = IDD_PPG_SECURITY };

protected:
	CPreferences*	m_pPrefs;
	bool			m_bModified;

	void SetModified(BOOL bChanged = TRUE)
	{
		m_bModified = bChanged;
		CPropertyPage::SetModified(bChanged);
	}
	virtual void DoDataExchange(CDataExchange* pDX);
	void LoadSettings(void);
	void SetDaysCaption(int iSliderPos);

	DECLARE_MESSAGE_MAP()

public:
	void SetPrefs(CPreferences* pPrefs)	{ m_pPrefs = pPrefs; }
	void Localize(void);
	virtual BOOL OnInitDialog();
	virtual BOOL OnApply();
	virtual BOOL OnSetActive();
	afx_msg void OnSettingsChange()		{ SetModified(); }
	afx_msg void OnBnClickedIpfilterUpdateButton();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnBnClickedIpfilterUpdateonstartCheck();
	afx_msg void OnBnClickedAvbrowse();
	afx_msg void OnBnClickedAvEnable();

protected:
	CString	m_strIPFilterGroupBox;
	CString	m_strFilterLevelStatic;
	CString	m_strIPFilterURLStatic;
	CString	m_strIPFilterURLEdit;
	BOOL	m_bFilterClientsCheck;
	BOOL	m_bFilterServersCheck;
	BOOL	m_bIPFilterUpdateOnStartCheck;
	BOOL	m_bFileScanFilterCheck;
	BOOL	m_bFakeDataFilterCheck;
	CString	m_strAVGroupBox;
	CString	m_strAVParamsStatic;
	CString	m_strAVPathStatic;
	BOOL	m_bAVEnabledCheck;
	BOOL	m_bAVScanCompletedCheck;
	CString	m_strAVParams;
	CString	m_strAVPath;
private:
	CButton	m_FilterClientsCheck;
	CButton	m_FilterServersCheck;
	CButton	m_IPFilterUpdateOnStartCheck;
	CButton	m_FileScanFilterCheck;
	CButton	m_FakeDataFilterCheck;
	CButton m_IPFilterUpdateButton;
	CSpinButtonCtrl m_FilterLevelSpinCtrl;
	CSliderCtrl m_UpdateDaysSlider;
	CString m_strUpdateDaysStatic;
	CStatic	m_UpdateDaysStatic;
	CButton	m_AVScanCompletedCheck;
	CButton	m_AVEnabledCheck;
	CButton	m_AVBrowseButton;
	CEdit	m_strAVParamsEdit;
	CEdit	m_strAVPathEdit;
};
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
